/*  Copyright (C) MOXA Inc. All rights reserved.

    This software is distributed under the terms of the
    MOXA License.  See the file COPYING-MOXA for details.
*/
/*
    bufqm.h

    This is a header file for buffer management.

    2009-8-25	CF Lin
		new release
*/
#ifndef _BUFQMR_H_
#define _BUFQMR_H_
#include "buffer.h"

typedef struct _BUFQMR
{
    BUFFER		*head;		/* header */
	spinlock_t	lock_qmr;
} BUFQMR;

void bufqmr_free(BUFQMR *q);
BUFQMR* bufqmr_new(int num_buf, int buf_size);
void bufqmr_append_buffer(BUFQMR *q, BUFFER *b);
void bufqmr_push_buffer(BUFQMR *q, BUFFER *b);
BUFFER* bufqmr_pop_buffer(BUFQMR *q);

#endif /* _BUFQMR_H_ */

